package com.ruoyi.zdsz.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.helper.LoginHelper;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.zdsz.domain.ZEngiineeringPhoto;
import com.ruoyi.zdsz.domain.ZEngineeringInfrastructure;
import com.ruoyi.zdsz.domain.ZEngineeringPipeJacking;
import com.ruoyi.zdsz.domain.bo.*;
import com.ruoyi.zdsz.domain.vo.*;
import com.ruoyi.zdsz.mapper.ZEngineeringInfrastructureMapper;
import com.ruoyi.zdsz.service.IZEngiineeringPhotoService;
import com.ruoyi.zdsz.service.IZEngineeringInfrastructureService;
import com.ruoyi.zdsz.service.IZEngineeringNodeService;
import com.ruoyi.zdsz.service.IZEngineeringReviewService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.ObjectUtils;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 基建工程Service业务层处理
 *
 * @author ruoyi
 * @date 2024-01-03
 */
@RequiredArgsConstructor
@Service
public class ZEngineeringInfrastructureServiceImpl implements IZEngineeringInfrastructureService {

    @Resource
    private final ZEngineeringInfrastructureMapper baseMapper;

    @Resource
    private final IZEngineeringNodeService izEngineeringNodeService;
    @Resource
    private IZEngiineeringPhotoService photoService;

    @Resource
    private final IZEngineeringReviewService izEngineeringReviewService;

    /**
     * 查询基建工程
     */
    @Override
    public ZEngineeringInfrastructureVo queryById(String id){
        ZEngineeringInfrastructureVo vo = baseMapper.selectVoById(id);
        ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
        zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
        zEngineeringNodeBo.setCivliId(vo.getId());
        vo.setzEngineeringNodeBoList(izEngineeringNodeService.queryListDetails(zEngineeringNodeBo));
        List<ZEngineeringNodeBo> nodeList = vo.getzEngineeringNodeBoList();
        //文件
        ZEngiineeringPhotoBo bo1 = new ZEngiineeringPhotoBo();
        bo1.setParentId(vo.getId());
        bo1.setCreateTime(vo.getCreateTime());
        vo.setPics(photoService.queryList(bo1));

        if(nodeList != null && nodeList.size() > 0){
            for (ZEngineeringNodeBo node : nodeList) {
                String type = node.getType();
//                if(node.getType().equals("construction_entrance")){
                if(type.equals("construction_hydroelectricity") || type.equals("construction_waterproof")){ // 水电施工、防水
                    ZEngineeringReviewBo reviewBo = izEngineeringReviewService.query(node);
                    boolean review = (reviewBo!=null) && (reviewBo.getReviewStatus().equals("1"));
                    node.setReviewStatus(review?"1":"0"); // 通过-1 未通过、未审核-0 无需审核-null
                }
            } // else null
        }
        return vo;
    }

    /**
     * 查询基建工程历史
     */
    @Override
    public ZEngineeringInfrastructureVo queryByIdType(String id, String type){
        ZEngineeringInfrastructureVo vo = baseMapper.selectVoById(id);
        ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
        zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
        zEngineeringNodeBo.setCivliId(vo.getId());
        zEngineeringNodeBo.setType(type);
        ZEngineeringNodeBo node = izEngineeringNodeService.query(zEngineeringNodeBo);
        if(node != null){
//            for (ZEngineeringNodeBo node : nodeList) {
            String type1 = node.getType();
//                if(node.getType().equals("construction_entrance")){
            if(type1.equals("construction_hydroelectricity") || type1.equals("construction_waterproof")){ // 水电施工、防水
                ZEngineeringReviewBo reviewBo = izEngineeringReviewService.query(node);
                boolean review = (reviewBo!=null) && (reviewBo.getReviewStatus().equals("1"));
                node.setReviewStatus(review?"1":"0"); // 通过-1 未通过、未审核-0 无需审核-null
            }
//            } // else null
        }

        vo.setzEngineeringNodeBo(node);
        return vo;
    }

    /**
     * 查询基建工程下拉
     */
    @Override
    public List<ZEngineeringInfrastructureSelectVo> select(ZEngineeringInfrastructureBo bo) {
        LambdaQueryWrapper<ZEngineeringInfrastructure> lqw = buildQueryWrapper(bo);
        List<ZEngineeringInfrastructureVo> result = baseMapper.selectVoList(lqw);
        List<ZEngineeringInfrastructureSelectVo> list = new ArrayList();
        for (ZEngineeringInfrastructureVo vo: result) {
            ZEngineeringInfrastructureSelectVo select = BeanUtil.toBean(vo, ZEngineeringInfrastructureSelectVo.class);
            list.add(select);
        }
        return list;
    }

    /**
     * 查询基建工程列表
     */
    @Override
    public TableDataInfo<ZEngineeringInfrastructureVo> queryPageList(ZEngineeringInfrastructureBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ZEngineeringInfrastructure> lqw = buildQueryWrapper(bo);
        Page<ZEngineeringInfrastructureVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询基建工程列表
     */
    @Override
    public List<ZEngineeringInfrastructureVo> queryList(ZEngineeringInfrastructureBo bo) {
        LambdaQueryWrapper<ZEngineeringInfrastructure> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ZEngineeringInfrastructure> buildQueryWrapper(ZEngineeringInfrastructureBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ZEngineeringInfrastructure> lqw = Wrappers.lambdaQuery();
        lqw.like(StringUtils.isNotBlank(bo.getEnginName()), ZEngineeringInfrastructure::getEnginName, bo.getEnginName());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginAddre()), ZEngineeringInfrastructure::getEnginAddre, bo.getEnginAddre());
        lqw.eq(StringUtils.isNotBlank(bo.getConstructUnit()), ZEngineeringInfrastructure::getConstructUnit, bo.getConstructUnit());
        lqw.eq(bo.getStartTime() != null, ZEngineeringInfrastructure::getStartTime, bo.getStartTime());
        lqw.eq(StringUtils.isNotBlank(bo.getPlannedDuration()), ZEngineeringInfrastructure::getPlannedDuration, bo.getPlannedDuration());
        lqw.eq(bo.getCompletedTime() != null, ZEngineeringInfrastructure::getCompletedTime, bo.getCompletedTime());
        lqw.eq(StringUtils.isNotBlank(bo.getEnginContent()), ZEngineeringInfrastructure::getEnginContent, bo.getEnginContent());
        return lqw;
    }

    /**
     * 新增基建工程
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean insertByBo(ZEngineeringInfrastructureBo bo) {
        ZEngineeringInfrastructure add = BeanUtil.toBean(bo, ZEngineeringInfrastructure.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            List<ZEngineeringNodeBo> nodeBoList = bo.getzEngineeringNodeBoList();
            if(nodeBoList != null && nodeBoList.size() != 0){
                for (ZEngineeringNodeBo nodeBo:nodeBoList) {
                    bo.setId(add.getId());
                    ZEngineeringNodeBo zEngineeringNodeBo = nodeBo;
                    zEngineeringNodeBo.setCivliId(add.getId());
                    zEngineeringNodeBo.setCreateTime(add.getCreateTime());
                    izEngineeringNodeService.insert(zEngineeringNodeBo);
                }
            }else {

                bo.setId(add.getId());
                ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
                zEngineeringNodeBo.setCivliId(add.getId());
                zEngineeringNodeBo.setType(zEngineeringNodeBo.getType());
                zEngineeringNodeBo.setCreateTime(add.getCreateTime());
                ZEngineeringNodeBo query = izEngineeringNodeService.query(zEngineeringNodeBo);
                if (!ObjectUtils.isEmpty(query)) {
                    zEngineeringNodeBo.setId(query.getId());
                }
                izEngineeringNodeService.insert(bo.getzEngineeringNodeBo());
            }
            //文件集合
            if (!bo.getFiles().isEmpty()){
                List<ZEngiineeringPhoto> list = new ArrayList<>();
                bo.getFiles().forEach(o->{
                    ZEngiineeringPhoto pic = new ZEngiineeringPhoto();
                    pic.setParentId(bo.getId());
                    pic.setPicUrl(o.getUrl());
                    pic.setFileName(o.getName());
                    pic.setCreateBy(String.valueOf(LoginHelper.getUserId()));
                    pic.setCreateTime(new Date());
                    pic.setUpdateBy(String.valueOf(LoginHelper.getUserId()));
                    pic.setUpdateTime(new Date());
                    list.add(pic);
                });
                if (!list.isEmpty()) {
                    photoService.insertBatch(list);
                }
            }
        }
        return flag;
    }
    private void doPhotos(ZEngineeringInfrastructure update, ZEngineeringInfrastructureBo bo) {
        List<ZEngiineeringPhoto> list = new ArrayList<>();

        // 查询数据库中已存在的文件列表
        ZEngiineeringPhotoBo bo1 = new ZEngiineeringPhotoBo();
        bo1.setParentId(update.getId());
        bo1.setCreateTime(update.getCreateTime());
        List<String> existingPhotos = photoService.queryList(bo1).stream()
            .map(ZEngiineeringPhotoVo::getPicUrl)
            .collect(Collectors.toList());

        // 插入前端传来的新文件
        for (ZFileBo pic : bo.getFiles()) {
            if (!existingPhotos.contains(pic.getUrl())) {
                ZEngiineeringPhoto newPhoto = new ZEngiineeringPhoto();
                newPhoto.setParentId(bo.getId());
                newPhoto.setPicUrl(pic.getUrl());
                newPhoto.setFileName(pic.getName());
                newPhoto.setCreateBy(String.valueOf(LoginHelper.getUserId()));
                newPhoto.setUpdateBy(String.valueOf(LoginHelper.getUserId()));
                newPhoto.setCreateTime(bo.getCreateTime());
                newPhoto.setUpdateTime(new Date());
                list.add(newPhoto);
            }
        }

        // 删除数据库中多余的文件
        List<String> photosToDelete = existingPhotos.stream()
            .filter(pic -> !bo.getFiles().stream().map(ZFileBo::getUrl).collect(Collectors.toList()).contains(pic))
            .collect(Collectors.toList());
        if (!photosToDelete.isEmpty()) {
            photosToDelete.forEach(item->{
                ZEngiineeringPhoto zEngiineeringPhoto=new ZEngiineeringPhoto();
                zEngiineeringPhoto.setPicUrl(item);
                zEngiineeringPhoto.setCreateTime(bo.getCreateTime());
                photoService.deleteWithValid(zEngiineeringPhoto);
            });
        }

        // 批量插入新图片
        if (!list.isEmpty()) {
            photoService.insertBatch(list);
        }
    }
    /**
     * 新增基建工程审核
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean review(ZEngineeringReviewBo bo) {
        ZEngineeringReviewBo zEngineeringReviewBo = new ZEngineeringReviewBo();
        zEngineeringReviewBo.setEngInfoId(bo.getEngInfoId());
        List<ZEngineeringReviewVo> voList = izEngineeringReviewService.queryList(zEngineeringReviewBo);
        if(voList.size() == 0){
            return izEngineeringReviewService.insert(bo);
        }else {
            bo.setId(voList.get(0).getId());
            return izEngineeringReviewService.updateByBo(bo);
        }
    }

    /**
     * 修改基建工程
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean updateByBo(ZEngineeringInfrastructureBo bo) {
        ZEngineeringInfrastructure update = BeanUtil.toBean(bo, ZEngineeringInfrastructure.class);
        validEntityBeforeSave(update);
        boolean flag = baseMapper.updateById(update) > 0;
        if (flag) {
            ZEngineeringInfrastructureVo vo = baseMapper.selectVoById(update.getId());
            //文件
            this.doPhotos(update,bo);
            ZEngineeringNodeBo zEngineeringNodeBo = bo.getzEngineeringNodeBo();
            if (!ObjectUtils.isEmpty(zEngineeringNodeBo)){
                zEngineeringNodeBo.setCivliId(vo.getId());
                zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
                izEngineeringNodeService.update(zEngineeringNodeBo);
            }
            }
//        }
        return flag;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ZEngineeringInfrastructure entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除基建工程
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        ids.forEach(item -> {
            ZEngineeringInfrastructureVo vo = baseMapper.selectVoById(item);
            if(vo==null)
            {return;}
            ZEngineeringNodeBo zEngineeringNodeBo = new ZEngineeringNodeBo();
            zEngineeringNodeBo.setCreateTime(vo.getCreateTime());
            zEngineeringNodeBo.setCivliId(vo.getId());
            List<ZEngineeringNodeBo> zEngineeringNodeBos = izEngineeringNodeService.queryListDetails(zEngineeringNodeBo);
            zEngineeringNodeBos.forEach(ite -> izEngineeringNodeService.delete(ite));
        }); return baseMapper.deleteBatchIds(ids) > 0;
    }
}
